Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref	(revision 13233)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/cfgs/SHARED/namelist_pisces_ref	(revision 13234)
@@ -202,56 +202,54 @@
 &namp4zmes     !   parameters for mesozooplankton for PISCES std       - ln_p4z
 !-----------------------------------------------------------------------
+   part2       =  0.75     ! part of calcite not dissolved in mesozoo guts
+   grazrat2    =  0.5      ! maximal mesozoo grazing rate
+   resrat2     =  0.005    ! exsudation rate of mesozooplankton
+   mzrat2      =  0.02     ! mesozooplankton mortality rate
+   xpref2d     =  1.       ! mesozoo preference for diatoms
+   xpref2n     =  0.3      ! mesozoo preference for nanophyto.
+   xpref2z     =  1.       ! mesozoo preference for microzoo.
+   xpref2c     =  0.3      ! mesozoo preference for poc
+   xthresh2zoo = 1E-8      ! zoo feeding threshold for mesozooplankton 
+   xthresh2dia = 1E-8      ! diatoms feeding threshold for mesozooplankton 
+   xthresh2phy = 1E-8      ! nanophyto feeding threshold for mesozooplankton 
+   xthresh2poc = 1E-8      ! poc feeding threshold for mesozooplankton 
+   xthresh2    =  3E-7     ! Food threshold for grazing
+   xkgraz2     =  20.E-6   ! half saturation constant for meso grazing
+   epsher2     =  0.35     ! Efficicency of Mesozoo growth
+   epsher2min  =  0.35     ! Minimum efficiency of mesozoo growth
+   sigma2      =  0.6      ! Fraction of mesozoo excretion as DOM
+   unass2      =  0.3      ! non assimilated fraction of P by mesozoo
+   grazflux    =  3.e3     ! flux-feeding rate
+   ln_dvm_meso = .false.   ! Activates DVM for mesozooplankton
+   xfracmig    = 0.3       ! Fraction of mesozooplankton performing DVM
+/
+!-----------------------------------------------------------------------
+&namp5zmes     !   parameters for mesozooplankton
+!-----------------------------------------------------------------------
    part2      =  0.75     ! part of calcite not dissolved in mesozoo guts
-   grazrat2   =  0.55     ! maximal mesozoo grazing rate
-   resrat2    =  0.005    ! Linear mortality rate of mesozooplankton
-   mzrat2     =  0.025    ! mesozooplankton mortality rate
-   xpref2d    =  1.       ! mesozoo preference for diatoms
-   xpref2n    =  0.3      ! mesozoo preference for nanophyto.
-   xpref2z    =  1.       ! mesozoo preference for microzoo.
-   xpref2c    =  0.3      ! mesozoo preference for poc
-   xthresh2zoo = 1E-8     ! zoo feeding threshold for mesozooplankton 
-   xthresh2dia = 1E-8     ! diatoms feeding threshold for mesozooplankton 
-   xthresh2phy = 1E-8     ! nanophyto feeding threshold for mesozooplankton 
-   xthresh2poc = 1E-8     ! poc feeding threshold for mesozooplankton 
-   xthresh2   =  3E-7     ! Food threshold for grazing
-   xkgraz2    =  20.E-6   ! half saturation constant for meso grazing
-   epsher2    =  0.35     ! Efficicency of Mesozoo growth
-   epsher2min =  0.35     ! Minimum efficiency of mesozoo growth
-   sigma2     =  0.6      ! Fraction of mesozoo excretion as DOM
-   unass2     =  0.3      ! non assimilated fraction of P by mesozoo
+   grazrat2   =  0.75     ! maximal mesozoo grazing rate
+   bmetexc2   =  .true.   ! Metabolic use of excess carbon 
+   resrat2    =  0.005    ! exsudation rate of mesozooplankton
+   mzrat2     =  0.03     ! mesozooplankton mortality rate
+   xpref2d    =  1.       ! meso preference for diatoms
+   xpref2n    =  0.3      ! meso preference for nano
+   xpref2z    =  1.       ! meso preference for zoo
+   xpref2m    =  0.1      ! meso preference for zoo
+   xpref2c    =  0.3      ! meso preference for poc
+   xthresh2zoo = 1E-8     ! zoo feeding threshold for mesozooplankton
+   xthresh2dia = 1E-8     ! diatoms feeding threshold for mesozooplankton
+   xthresh2phy = 1E-8     ! nanophyto feeding threshold for mesozooplankton
+   xthresh2mes = 1E-8     ! meso feeding threshold for mesozooplankton
+   xthresh2poc = 1E-8     ! poc feeding threshold for mesozooplankton
+   xthresh2    =  3E-7    ! Food threshold for grazing
+   xkgraz2     =  20.E-6  ! half sturation constant for meso grazing
+   epsher2     =  0.5     ! Efficicency of Mesozoo growth
+   epsher2min  =  0.5     ! Minimum efficiency of mesozoo growth
+   ssigma2     =  0.5     ! Fraction excreted as semi-labile DOM
+   srespir2    =  0.2     ! Active respiration
+   unass2c     =  0.3     ! non assimilated fraction of C by mesozoo
+   unass2n     =  0.3     ! non assimilated fraction of N by mesozoo
+   unass2p     =  0.3     ! non assimilated fraction of P by mesozoo
    grazflux   =  3.e3     ! flux-feeding rate
-   ln_dvm_meso = .false.  ! Activates DVM for mesozooplankton
-   xfracmig    = 0.3      ! Fraction of mesozooplankton performing DVM
-/
-!-----------------------------------------------------------------------
-&namp5zmes     !   parameters for mesozooplankton
-!-----------------------------------------------------------------------
-   part2       = 0.75    ! part of calcite not dissolved in mesozoo guts
-   grazrat2    = 0.75    ! maximal mesozoo grazing rate
-   bmetexc2    = .true.  ! Metabolic use of excess carbon 
-   resrat2     = 0.005   ! Linear mortality rate of mesozooplankton
-   mzrat2      = 0.03    ! mesozooplankton mortality rate
-   xpref2d     = 1.      ! meso preference for diatoms
-   xpref2n     = 0.3     ! meso preference for nano
-   xpref2z     = 1.      ! meso preference for zoo
-   xpref2m     = 0.1     ! meso preference for zoo
-   xpref2c     = 0.3     ! meso preference for poc
-   xthresh2zoo = 1E-8    ! zoo feeding threshold for mesozooplankton
-   xthresh2dia = 1E-8    ! diatoms feeding threshold for mesozooplankton
-   xthresh2phy = 1E-8    ! nanophyto feeding threshold for mesozooplankton
-   xthresh2mes = 1E-8    ! meso feeding threshold for mesozooplankton
-   xthresh2poc = 1E-8    ! poc feeding threshold for mesozooplankton
-   xthresh2    = 3E-7    ! Food threshold for grazing
-   xkgraz2     = 20.E-6  ! half sturation constant for meso grazing
-   epsher2     = 0.5     ! Efficicency of Mesozoo growth
-   epsher2min  = 0.5     ! Minimum efficiency of mesozoo growth
-   ssigma2     = 0.5     ! Fraction excreted as semi-labile DOM
-   srespir2    = 0.2     ! Active respiration
-   unass2c     = 0.3     ! non assimilated fraction of C by mesozoo
-   unass2n     = 0.3     ! non assimilated fraction of N by mesozoo
-   unass2p     = 0.3     ! non assimilated fraction of P by mesozoo
-   grazflux    = 3.e3    ! flux-feeding rate
-   ln_dvm_meso = .false.  ! Activates DVM for mesozooplankton
-   xfracmig    = 0.3      ! Fraction of mesozooplankton performing DVM
 /
 !-----------------------------------------------------------------------
@@ -281,5 +279,5 @@
    grazrat    =  3.0      ! maximal zoo grazing rate
    bmetexc    =  .true.   ! Metabolic use of excess carbon
-   resrat     =  0.03     ! Linear mortality rate of zooplankton
+   resrat     =  0.03     ! exsudation rate of zooplankton
    mzrat      =  0.004    ! zooplankton mortality rate
    xprefc     =  0.1      ! Microzoo preference for POM
@@ -307,7 +305,7 @@
 !-----------------------------------------------------------------------
    ln_ligvar =  .false.   ! variable ligand concentration
-   xlam1     =  0.005     ! scavenging rate of Iron by biogenic particles
+   xlam1     =  0.005      ! scavenging rate of Iron by biogenic particles
    xlamdust  =  150.0     ! Scavenging rate of Iron by dust
-   ligand    =  0.7E-9    ! Ligands concentration 
+   ligand    =  7E-10     ! Ligands concentration 
    kfep      =  0.01      ! Nanoparticle formation rate constant
 /
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 13233)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 13234)
@@ -474,5 +474,5 @@
          &                xpref2c, xthresh2dia, xthresh2phy, xthresh2zoo, xthresh2poc, &
          &                xthresh2, xkgraz2, epsher2, epsher2min, sigma2, unass2, grazflux, ln_dvm_meso,  &
-         &                xfracmig
+         &                xsigma2, xsigma2del, xfracmig
       !!----------------------------------------------------------------------
       !
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 13233)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 13234)
@@ -300,5 +300,5 @@
       NAMELIST/namp4zzoo/ part, grazrat, resrat, mzrat, xprefn, xprefc, &
          &                xprefd,  xthreshdia,  xthreshphy,  xthreshpoc, &
-         &                xthresh, xkgraz, epsher, epshermin, sigma1, unass  &
+         &                xthresh, xkgraz, epsher, epshermin, sigma1, unass,  &
          &                xsigma, xsigmadel
       !!----------------------------------------------------------------------
Index: /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zmeso.F90
===================================================================
--- /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zmeso.F90	(revision 13233)
+++ /NEMO/branches/2019/dev_r11708_aumont_PISCES_QUOTA/src/TOP/PISCES/P4Z/p5zmeso.F90	(revision 13234)
@@ -588,5 +588,5 @@
          &                xpref2m, xpref2d, xthresh2dia, xthresh2phy, xthresh2zoo, xthresh2poc, &
          &                xthresh2mes, xthresh2, xkgraz2, epsher2, epsher2min, ssigma2, unass2c, &
-         &                unass2n, unass2p, srespir2, grazflux, ln_dvm_meso, xfracmig
+         &                unass2n, unass2p, srespir2, xsigma2, xsigma2del, grazflux, ln_dvm_meso, xfracmig
       !!----------------------------------------------------------------------
       !
@@ -629,4 +629,6 @@
          WRITE(numout,*) '    half sturation constant for grazing 2          xkgraz2     = ', xkgraz2
          WRITE(numout,*) '    Use excess carbon for respiration              bmetexc2    = ', bmetexc2
+         WRITE(numout,*) '      Width of the grazing window                     xsigma2     =', xsigma2
+         WRITE(numout,*) '      Maximum additional width of the grazing window  xsigma2del  =', xsigma2del
          WRITE(numout,*) '      Diurnal vertical migration of mesozoo.         ln_dvm_meso  =', ln_dvm_meso
          WRITE(numout,*) '      Fractional biomass of meso  that performs DVM  xfracmig     =', xfracmig